import { autocompletion as I, completionKeymap as O, closeBrackets as j, closeBracketsKeymap as B } from "@codemirror/autocomplete";
import { indentWithTab as L, insertNewline as R } from "@codemirror/commands";
import { css as K } from "@codemirror/lang-css";
import { html as V } from "@codemirror/lang-html";
import { json as z } from "@codemirror/lang-json";
import { xml as A } from "@codemirror/lang-xml";
import { yaml as D } from "@codemirror/lang-yaml";
import { syntaxHighlighting as P, defaultHighlightStyle as G, indentOnInput as J, bracketMatching as y, foldGutter as U } from "@codemirror/language";
import { linter as W } from "@codemirror/lint";
import { StateEffect as q } from "@codemirror/state";
import { EditorView as a, highlightSpecialChars as Q, keymap as d, placeholder as X, lineNumbers as Y } from "@codemirror/view";
import { ScalarIcon as Z } from "@scalar/components";
import { ref as _, watch as g, onBeforeUnmount as F, toValue as t, computed as $, h as ee, render as te } from "vue";
import { customTheme as oe } from "../themes/index.js";
import { variables as re } from "./variables.js";
const u = (e) => "provider" in e && !!t(e.provider), ne = {
  key: "Mod-a",
  run: (e) => (e.dispatch({
    selection: { anchor: 0, head: e.state.doc.length },
    scrollIntoView: !1
  }), !0)
}, ke = (e) => {
  const r = _(null);
  g(
    e.codeMirrorRef,
    () => {
      var o;
      (o = r.value) == null || o.destroy(), c();
    },
    { immediate: !0 }
  ), F(() => {
    var o;
    return (o = r.value) == null ? void 0 : o.destroy();
  });
  function c() {
    if (e.codeMirrorRef.value) {
      const o = u(e) ? t(e.provider) : null, h = x({
        ...f.value,
        provider: o
      });
      r.value = new a({
        parent: e.codeMirrorRef.value,
        extensions: h
      }), u(e) || l(t(e.content));
    }
  }
  const f = $(() => ({
    onChange: e.onChange,
    onBlur: e.onBlur,
    onFocus: e.onFocus,
    disableTabIndent: t(e.disableTabIndent),
    language: t(e.language),
    classes: t(e.classes),
    readOnly: t(e.readOnly),
    lineNumbers: t(e.lineNumbers),
    withVariables: t(e.withVariables),
    disableEnter: t(e.disableEnter),
    disableCloseBrackets: t(e.disableCloseBrackets),
    withoutTheme: t(e.withoutTheme),
    lint: t(e.lint),
    additionalExtensions: t(e.extensions),
    placeholder: t(e.placeholder)
  }));
  g(
    () => u(e) ? t(e.provider) : null,
    () => {
      var o;
      u(e) && ((o = r.value) == null || o.destroy(), c());
    }
  ), g(
    f,
    () => {
      if (r.value) {
        const o = u(e) ? t(e.provider) : null, h = x({
          ...f.value,
          provider: o
        });
        r.value.dispatch({
          effects: q.reconfigure.of(h)
        });
      } else
        return;
    },
    { immediate: !0 }
  );
  const l = (o = "") => {
    r.value && r.value.state.doc.toString() !== o && r.value.dispatch({
      changes: {
        from: 0,
        to: r.value.state.doc.length,
        insert: o
      },
      selection: {
        anchor: Math.min(
          r.value.state.selection.main.anchor,
          o.length
        )
      }
    });
  };
  return g(
    () => t(e.content),
    () => {
      u(e) || l(t(e.content));
    },
    { immediate: !0 }
  ), {
    /** Replaces the current content with the given value. */
    setCodeMirrorContent: l,
    /** Codemirror instance */
    codeMirror: r
  };
}, k = {
  html: V,
  json: z,
  yaml: D,
  css: K,
  xml: A
};
function x({
  onChange: e,
  onBlur: r,
  onFocus: c,
  provider: f,
  language: l,
  classes: o = [],
  readOnly: h = !1,
  lineNumbers: E = !1,
  withVariables: C = !1,
  disableEnter: M = !1,
  disableCloseBrackets: S = !1,
  disableTabIndent: T = !1,
  withoutTheme: w = !1,
  lint: N = !1,
  additionalExtensions: H = [],
  placeholder: p
}) {
  const n = [
    Q(),
    P(G, { fallback: !0 }),
    a.theme({
      ".cm-line": {
        lineHeight: "20px",
        padding: "0 2px 0 4px"
      },
      ".cm-gutterElement": {
        lineHeight: "20px"
      },
      ".cm-tooltip": {
        border: "1px solid #f5c6cb",
        fontSize: "12px"
      },
      ".cm-tooltip-lint": {
        backgroundColor: "#ffffff"
      },
      ".cm-diagnostic-error": {
        borderLeft: "0",
        color: "#dc1b19"
      },
      ".cm-foldPlaceholder": {
        background: "var(--scalar-background-1)",
        border: "none",
        fontFamily: "var(--scalar-font)"
      },
      ".cm-line::selection": {
        background: "var(--scalar-selection-background) !important",
        color: "var(--scalar-selection-color)"
      }
    }),
    // Listen to updates
    a.updateListener.of((s) => {
      s.docChanged && (e == null || e(s.state.doc.toString()));
    }),
    a.domEventHandlers({
      blur: (s, i) => {
        r == null || r(i.state.doc.toString());
      },
      focus: (s, i) => {
        c == null || c(i.state.doc.toString());
      }
    }),
    // Add Classes
    a.editorAttributes.of({ class: o.join(" ") }),
    ...H
  ];
  if (f && n.push(f), w || n.push(oe), h ? n.push(a.editable.of(!1)) : (n.push(
    J(),
    y(),
    I(),
    d.of([...O, ne]),
    y()
  ), S || n.push(j(), d.of([...B])), T ? n.push(
    d.of([
      {
        key: "Tab",
        run: () => !1,
        // Prevent default Tab behavior
        shift: () => !1
        // Prevent default Shift+Tab behavior
      }
    ])
  ) : n.push(d.of([L]))), p && n.push(X(p)), E && n.push(Y()), l && k[l] && n.push(
    k[l](),
    U({
      markerDOM: (s) => {
        const i = document.createElement("div");
        i.classList.add("cm-foldMarker");
        const m = ee(Z, {
          icon: s ? "ChevronDown" : "ChevronRight",
          size: "xs"
        });
        return te(m, i), i;
      }
    })
  ), N && l === "json") {
    const s = W((i) => {
      const m = [], b = i.state.doc.toString();
      if (b.trim())
        try {
          JSON.parse(b);
        } catch (v) {
          v instanceof Error && m.push({
            from: 0,
            to: i.state.doc.length,
            severity: "error",
            message: v.message
          });
        }
      return m;
    });
    n.push(s);
  }
  return C && n.push(re()), M ? n.push(
    d.of([
      {
        key: "Enter",
        run: () => !0
      },
      {
        key: "Ctrl-Enter",
        mac: "Cmd-Enter",
        run: () => !0
      },
      {
        key: "Shift-Enter",
        run: () => !0
      }
    ])
  ) : n.push(
    d.of([
      {
        key: "Enter",
        run: R
      }
    ])
  ), n;
}
export {
  ke as useCodeMirror
};
